#include "ClockCounter.h"

// constructor
ClockCounter::ClockCounter( sc_module_name name )
    : sc_module( name )
    , clk( "clk" )
    , CntOut( "CntOut" )
{
    // process setting
    SC_THREAD( main_thread );
    //sensitive << clk.pos();
}

void ClockCounter::main_thread()
{
    unsigned int cnt = 0;
    CntOut.write( 0 );

    while (true)
    {
        //wait();
         wait( clk.posedge_event() );

         ++cnt;
         CntOut.write( cnt );
    }
}
